﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinSchedule
Imports Infragistics.Win.UltraWinSchedule.DayView

Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.UltraDayView1.DrawFilter = New AppointmentDrawFilter()
        Me.UltraCalendarInfo1.Owners.UnassignedOwner.Visible = False
        Me.UltraCalendarInfo1.Owners.Add("Welby", "Dr. Marcus Welby")
        Me.UltraCalendarInfo1.Owners.Add("Kimble", "Dr. Richard Kimble")
        Me.UltraCalendarInfo1.Owners.Add("Quincy", "Dr. Quincy")
        Me.UltraCalendarInfo1.Owners.Add("Spencer", "Dr. Luke Spencer")
        Me.UltraDayView1.GroupingStyle = DayViewGroupingStyle.OwnerWithinDate
        Me.UltraDayView1.TimeSlotInterval = TimeSlotInterval.ThirtyMinutes

        Dim startDate1 = New DateTime(2017, 10, 25, 9, 0, 0)
        Dim endDate1 = New DateTime(2017, 10, 25, 10, 0, 0)
        Dim appointment1 = New Appointment(startDate1, endDate1)
        appointment1.Owner = Me.UltraCalendarInfo1.Owners(1)
        appointment1.Subject = "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore"
        appointment1.Description = "Some test description 1"

        Dim startDate2 = New DateTime(2017, 10, 25, 11, 0, 0)
        Dim endDate2 = New DateTime(2017, 10, 25, 12, 0, 0)
        Dim appointment2 = New Appointment(startDate2, endDate2)
        appointment2.Owner = Me.UltraCalendarInfo1.Owners(2)
        appointment2.Subject = "Meeting"
        appointment2.Description = "Some test description 2"

        Me.UltraCalendarInfo1.Appointments.Add(appointment1)
        Me.UltraCalendarInfo1.Appointments.Add(appointment2)
    End Sub
End Class


Public Class AppointmentDrawFilter
    Implements IUIElementDrawFilter
#Region "DrawFilter"
    Private Function IUIElementDrawFilter_DrawElement(drawPhase As DrawPhase, ByRef drawParams As UIElementDrawParams) As Boolean Implements IUIElementDrawFilter.DrawElement
        Dim textElement = TryCast(drawParams.Element, EditorWithTextDisplayTextUIElement)
        If textElement IsNot Nothing Then
            Dim appointmentElement = TryCast(textElement.GetAncestor(GetType(AppointmentUIElement)), AppointmentUIElement)
            If appointmentElement IsNot Nothing Then
                'Get the appointment subject and description
                Dim appointment = appointmentElement.Appointment
                Dim appSubject = appointment.Subject
                Dim appDesc = appointment.Description

                'Get the size of the EditorWithTextDisplayTextUIElement
                Dim textElementRect = drawParams.Element.Rect
                Dim textElementRectWidth = textElementRect.Width
                Dim textElementRectHeight = textElementRect.Height
                Dim textElementRectLeft = textElementRect.Left
                Dim textElementRectTop = textElementRect.Top

                'Create bold font
                Dim boldFont = New Font(drawParams.Font, FontStyle.Bold)
                'Draw the subject with the bold font
                drawParams.Graphics.DrawString(appSubject, boldFont, Brushes.Black, textElementRect)

                'Get the size of the subject text string
                Dim appSubjectSize = drawParams.Graphics.MeasureString(appSubject, boldFont, textElementRectWidth)
                Dim appSubjectWidth = CInt(appSubjectSize.Width)
                Dim appSubjectHeight = CInt(appSubjectSize.Height)

                'Create new Rectangle for the description
                Dim appDescRectRight = textElementRectTop + appSubjectHeight
                Dim appDescRectHeight = textElementRectHeight - appSubjectHeight
                Dim appDescRect = New Rectangle(textElementRectLeft, appDescRectRight, textElementRectWidth, appDescRectHeight)
                drawParams.Element.Rect.Offset(0, appSubjectHeight)

                'Draw the appointment description
                drawParams.Graphics.DrawString(appDesc, drawParams.Font, Brushes.Black, appDescRect)

                boldFont.Dispose()
                Return True
            End If
        End If

        Return False
    End Function
#End Region

#Region "GetPhasesToFilter"
    Private Function IUIElementDrawFilter_GetPhasesToFilter(ByRef drawParams As UIElementDrawParams) As DrawPhase Implements IUIElementDrawFilter.GetPhasesToFilter
        If TypeOf drawParams.Element Is EditorWithTextDisplayTextUIElement Then
            Return DrawPhase.BeforeDrawForeground
        End If

        Return DrawPhase.None
    End Function
#End Region
End Class
